.\" Automatically generated by Pandoc 1.19.1
.\"
.TH "VORONOTA" "1" "May, 2017" "" ""
.hy
.SH NAME
.PP
Voronota \- software for Voronoi tessellation\-based analysis of
macromolecular structures
.SH SYNOPSIS
.PP
voronota \f[I]command\f[] [\f[I]options\f[]]...
.PP
voronota\-voromqa [\f[I]options\f[]]...
.PP
voronota\-cadscore [\f[I]options\f[]]...
.PP
voronota\-contacts [\f[I]options\f[]]...
.PP
voronota\-volumes [\f[I]options\f[]]...
.SH DESCRIPTION
.PP
The analysis of macromolecular structures often requires a comprehensive
definition of atomic neighborhoods.
Such a definition can be based on the Voronoi diagram of balls, where
each ball represents an atom of some van der Waals radius.
Voronota is a software tool for finding all the vertices of the Voronoi
diagram of balls.
Such vertices correspond to the centers of the empty tangent spheres
defined by quadruples of balls.
Voronota is especially suitable for processing three\-dimensional
structures of biological macromolecules such as proteins and RNA.
.PP
Since version 1.2 Voronota also uses the Voronoi vertices to construct
inter\-atom contact surfaces and solvent accessible surfaces.
Voronota provides tools to query contacts, generate contacts graphics,
compare contacts and evaluate quality of protein structural models using
contacts.
.PP
The list of all available Voronota commands is displayed when executing
Voronota without any parameters.
.PP
Command help is shown when \f[C]\-\-help\f[] command line option is
present, for example:
.IP
.nf
\f[C]
voronota\ calculate\-vertices\ \-\-help
\f[]
.fi
.PP
Using \f[C]\-\-help\f[] option without specific command results in
printing help for all commands:
.IP
.nf
\f[C]
voronota\ \-\-help
\f[]
.fi
.PP
There are several Voronota wrapper scripts, their interfaces can
displayed similarly:
.IP
.nf
\f[C]
voronota\-voromqa\ \-\-help
voronota\-cadscore\ \-\-help
voronota\-contacts\ \-\-help
voronota\-volumes\ \-\-help
\f[]
.fi
.SH SEE ALSO
.PP
The \f[I]README\f[] file distributed with Voronota contains more
detailed documentation.
.PP
The Voronota source code and all the supporting files may be downloaded
from <https://bitbucket.org/kliment/voronota/downloads>.
.SH AUTHORS
Kliment Olechnovic.
